<template>
  <v-dialog
    :value="offer"
    @close="close"
    @click:outside="close"
    max-width="500px"
  >
    <v-card v-if="offer">
      <v-toolbar dense color="primary">
        <v-toolbar-title class="white--text">
          Закрыть
        </v-toolbar-title>
        <v-spacer />
        <v-btn @click="close" icon class="white--text">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-toolbar>
      <v-container>
        <v-row dense>
          <v-col cols="12">
            <v-alert type="warning">
              Вы действительно хотите закрыть сделку?
            </v-alert>
          </v-col>
          <v-col cols="12">
            <v-text-field
              label="Причина закрытия"
              v-model='note'
              hide-details
            />
          </v-col>
          <v-col cols="12">
            <v-btn
              @click="closeOffer"
              color="red darken-3"
              class="white--text"
              block
              :disabled="disabled"
            >
              Закрыть
            </v-btn>
          </v-col>
          <v-col cols="12">
            <v-btn
              @click="close"
              color="primary"
              class="white--text"
              block
              :disabled="disabled"
            >
              Отмена
            </v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>
</template>

<script lang='ts'>

import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import { CloseOfferCommand, OfferResponse } from '@/api/ledius-token';

@Component({})
export default class OfferCloseModal extends Vue {
  @Prop({
    required: false,
    default: null,
    validator(value: unknown): boolean {
      return typeof value === 'object' || value === null;
    }
  })
  private readonly offer!: OfferResponse | null;

  private readonly note: string = '';

  private disabled: boolean = false;

  private async closeOffer(): Promise<void> {
    if (this.offer) {
      try {
        this.disabled = true;
        await this.$store.dispatch('exchange/offers/close', {
          id: this.offer.id,
          note: this.note
        } as CloseOfferCommand);
        this.close();
      } finally {
        this.disabled = false;
      }
    }
  }

  private close(): void {
    this.$emit('update:offer', null);
  }
}

</script>

<style scoped>

</style>
